import requests
from bs4 import BeautifulSoup  # BeautifulSoup import

class Movie:
    def __init__(self, n, u, rank, reples):
        self.name = n
        self.url = u
        self.ranking = rank
        self.reples = reples

    def __str__(self):
        return str(self.ranking) + "위\t제목:" + self.name + "\t주소:" + self.url + "\n리플:" + str(self.reples)

class Naver:

    # 기본 정보
    movieHomeUrl = 'https://movie.naver.com'
    movieRankingHomeUrl = 'https://movie.naver.com/movie/sdb/rank/rmovie.nhn'
    soupHtmlParser = 'html.parser'

    # 영화 태그패턴
    moviePattern = 'div[class=tit3]'
    replePattern = 'div[class=score_reple]'

    def __init__(self):
        movieResponse = requests.get(self.movieRankingHomeUrl)
        movieHtml = movieResponse.text
        self.movieSoup = BeautifulSoup(movieHtml, self.soupHtmlParser)

    def getMovieReple(self, url):
        movieReples = []
        repleText = requests.get(self.movieHomeUrl + url).text
        repleSoup = BeautifulSoup(repleText, self.soupHtmlParser)
        for tag in repleSoup.select(self.replePattern):
            rep = tag.select('p').pop().text
            movieReples.append(rep)
        return movieReples

    def getTitles(self):
        titles = []
        for tag in self.movieSoup.select(self.moviePattern):
            titles.append(tag.text.strip().replace("\n", ""))
        return titles

    def getAlls(self):
        movies = []
        ranking = 1
        for tag in self.movieSoup.select(self.moviePattern):
            n = tag.text.strip().replace("\n", "")
            u = tag.find('a').get('href')
            repless = self.getMovieReple(u)
            t = n, u, ranking, repless                #   튜플
            print(t)
            m = Movie(n, u, ranking, repless)         #   Movie 클래스
            movies.append(m)
            ranking = ranking + 1
        return movies


# 클래스 사용
naver = Naver()
print(naver.getTitles())

for b in naver.getAlls():
    print(b)